<%
  /*------------------------------------------------------------------------ */
  /* %full_filespec:   Page_LoginSequences.jsp~idc_nmas#8:ascii:iman_plg#1 %          */
  /* %date_modified:   Thu Aug 30 10:10:29 2007 %                            */
  /* %derived_by:      prabhishek %                                            */
  /*------------------------------------------------------------------------ */
  /* Copyright (c) 2002 Novell, Inc.  All rights reserved.                   */
  /*------------------------------------------------------------------------ */
%>
<%@ page   pageEncoding = "utf-8"                                %>
<%@ page   contentType  = "text/html;charset=utf-8"              %>
<%@ page   import       = "com.novell.emframe.dev.eMFrameUtils,
                           com.novell.plugin.imanutil.constants.UIConst,
                           com.novell.plugin.imanutil.tags.Table,
                           com.novell.admin.nmas.WidgetID,
                           com.novell.plugin.imanutil.*"  %>
<%@ page   import       = "com.novell.admin.nmas.NMASConstants"  %>
<%@ page   import       = "com.novell.emframe.dev.D"             %>
<%@ taglib uri          = "/WEB-INF/iman.tld"    prefix = "iman" %>
<%@ taglib uri          = "/WEB-INF/c.tld"       prefix = "c"    %>
<%@ taglib uri          = "/WEB-INF/util.tld"    prefix = "nmas" %>

<iman:stringtable bundle = "NMASResources" />
<iman:stringtable bundle = "DevResources" />

<iman:include page = "NMAS/NMASIncludes_inc.jsp" />

<%
   try
   {
      HttpRequest httpRequest = new HttpRequest( request );

      Table   data         = (Table)httpRequest.getAttribute( WidgetID.TABLE_DATA );
      boolean isInPropBook = httpRequest.getAttributeAsBoolean( WidgetID.IS_IN_PROPERTY_BOOK );
      boolean isLoginPolicy = httpRequest.getAttributeAsBoolean( WidgetID.IS_LOGIN_POLICY );
      boolean showDefault   = httpRequest.getAttributeAsBoolean( WidgetID.SHOW_DEFAULT_SEQUENCE );
      boolean showAuthorized = httpRequest.getAttributeAsBoolean( WidgetID.SHOW_AUTHORIZED_SEQUENCES );

      int     numAuthorized   = 0;
      int     numUnauthorized = 0;
      boolean hasDefault      = false;

      if ( showAuthorized )
      {
         for ( int i = 0; i < data.getNumberOfRows(); i++ )
         {
            TableCell cell = data.getTableCell( i, data.getNumberOfCols() - 1 );

            if ( cell instanceof TableCellIcon )
            {
               numAuthorized++;
            }
            else
            {
               numUnauthorized++;
            }

            cell = data.getTableCell( i, data.getNumberOfCols() - 2 );

            if ( cell instanceof TableCellIcon )
            {
               hasDefault = true;
            }
         }
      }
%>
<html>
   <head>

      <nmas:stylesheet moduleName = "NMAS" />
      <iman:stylesheet />

      <nmas:dataTableScripts />

      <iman:include page = "NMAS/MiscUtil_js.jsp" />
      <nmas:utilScripts moduleName = "NMAS" />

      <script language = "JavaScript">

         <!-- Hide JavaScript from non-compliant browsers.

         <%/*--------------------------------------------------------------- */
           /* Set the focus on the first element of the login method list.   */
           /*--------------------------------------------------------------- */%>

         function onPageLoad()
         {
            utilPositionFooterDiv( 'headerDiv','bodyDiv','footerDiv' );

<%
      if ( !isInPropBook )
      {
%>
            utilSetFooterButtons( window.okButton | window.applyButton | window.cancelButton );
<%
      }
%>
         }

         <%/*--------------------------------------------------------------- */
           /* Figure out the nature of the user"s selection, and return the  */
           /* proper state for the servlet when we submit LMSelectForm.      */
           /*--------------------------------------------------------------- */%>

         function analyzeSelection( delArray )
         {
            <%--
            var   nextState = 'noneDeletable';
            var   atLeastOneIsFree = false;
            var   atLeastOneIsUsed = false;

            for ( var i = 0; i < delArray.length; i++ )
            {
               <%/* Find the selected login method in the list of available  */
                 /* login  methods in order to check the status.             */%>

               for ( var j = 0; j < <%= c.var("AvailableMethods.length") %>; j++ )
               {
                  if ( delArray[i] == document.LMDataForm.elements['AvailableMethods.' + j + '.rdn'].value )
                  {
                     <%/* We found the selected login method; now check its  */
                       /* status.                                            */%>

                     if ( "IN_USE" == document.LMDataForm.elements['AvailableMethods.' + j + '.status'].value )
                     {
                        atLeastOneIsUsed = true;
                     }
                     if ( "UNUSED" == document.LMDataForm.elements['AvailableMethods.' + j + '.status'].value )
                     {
                        atLeastOneIsFree = true;
                     }
                  }
               }
            }
            if ( atLeastOneIsFree )
            {
               <%/* At least one of the login methods selected for deletion  */
                 /* is free to be deleted.  Advise the administrator of the  */
                 /* irreversible consequences of this action.                */%>

               if
               (
                  !confirm
                  (
                     "<%= c.toScript(c.string("NMAS.LMDelete.Select.Warning")) %>"
                  )
               )
               {
                  <%/* The administrator cancelled the action; bug out.      */%>
                  nextState = 'initialState';
               }
               else
               {
                  nextState = 'someDeletable';
                  if ( !atLeastOneIsUsed )
                  {
                     nextState = 'allDeletable';
                  }
               }
            }
            return nextState;
            --%>
         }

         <%/*--------------------------------------------------------------- */
           /* Gather all selected items (ensuring that no more than one      */
           /* login method has been selected), set the proper query          */
           /* variables, and submit the request.                             */
           /*--------------------------------------------------------------- */%>

         function handleModify( )
         {
            var selectedIndex = document.LMSelectForm.elements['LMSelection'].options.selectedIndex;
            if ( selectedIndex == -1 )
            {
               <%/* The user has to select at least one item from the list.  */%>

               alert( "<iman:toScript><iman:string key = "NMAS.MustSelect" /></iman:toScript>" );
               return;
            }

            <%/* Disallow multiple selection; start by getting the count of  */
              /* the selected items.                                         */%>

            var selectionLength = document.LMSelectForm.elements['LMSelection'].options.length;
            var selectedCount = 0;
            var selectedMethod = "";
            for ( i = selectionLength - 1; i >= 0; i-- )
            {
               if ( document.LMSelectForm.elements[ 'LMSelection' ].options[ i ].selected == true )
               {
                  selectedMethod = document.LMSelectForm.elements[ 'LMSelection' ].options[ i ].value;
                  selectedCount++;
               }
            }
            if ( selectedCount > 1 )
            {
               <%/* Can"t view or modify more than one at a time; display    */
                 /* an alert.                                                */%>

               alert( "<iman:toScript><iman:string key = "NMAS.ModifyMethod.SelectOnlyOne" /></iman:toScript>" );
               return;
            }

            <%/* Send the selected method back to the servlet.  The task     */
              /* fw.ModifyObject expects a packed array, even for only one   */
              /* object.                                                     */%>

            var modArray = new Array( document.LMSelectForm.elements[ 'LMSelection' ].options[ selectedIndex ].value );
            document.LMModifyForm.elements[ 'eDir$target' ].value = pack( modArray );

            <%/* Check if we are modifying the enhanced password method */%>

            document.LMModifyForm.submit();
         }

         <%/*--------------------------------------------------------------- */
           /* Simply return true.                                            */
           /*--------------------------------------------------------------- */%>

         function isPageValid()
         {
            return true;
         }

         <%/*--------------------------------------------------------------- */
           /* Exit from this task.                                           */
           /*--------------------------------------------------------------- */%>

         function handleCancel()
         {
            document.CancelForm.submit();
         }

         <%/*--------------------------------------------------------------- */
           /* Ensure that at least one login method has been selected, and   */
           /* see if at least one of the selected items is free.  If not,    */
           /* tell the task that none can be deleted.  Is so, then figure    */
           /* out whether they can all be deleted, and tell the task.        */
           /*--------------------------------------------------------------- */%>

         function handleDeleteMethods( selectedIndices, tableData )
         {
            if ( selectedIndices == null || selectedIndices.length == 0 )
            {
               <%/* User has to select at least one item from the list.      */%>
               alert( "<iman:toScript><iman:string key = "NMAS.MustSelect" /></iman:toScript>" );
               return;
            }

            var delArray = new Array();
            var delIndex = 0;

            for ( i = 0; i < selectedIndices.length; i++ )
            {
                delArray[ delIndex ] = tableData[ selectedIndices[ i ]][ 0 ];
                delIndex++;
            }

            if ( confirm( "<iman:toScript><iman:string key = "NMAS.LSDelete.Subset.Confirm" /></iman:toScript>" ))
            {
               utilSetElementValue(
                  "<%= UIConst.PARAM_TASK_ACTION  %>",
                  "<%= NMASConstants.PARAM_NEXT_ACTION_DELETE %>" );

               utilSetElementValue(
                  "<%= UIConst.PARAM_DN_LIST %>",
                  pack( delArray ));

               utilSubmitDocumentForm( true );
            }
         }

         function doMakeDefault( selectedIndices, tableData )
         {
            if ( null == selectedIndices ||
                 0 == selectedIndices.length ||
                 1 <  selectedIndices.length )
            {
               alert( "<iman:toScript><iman:string key = "NMAS.JavaScript.Error.OneAndOnlyOne" /></iman:toScript>" );
               return;
            }

            if ( tableData[ selectedIndices[ 0 ]][ 3 ] == "" )
            {
               alert( "<iman:toScript><iman:string key = "NMAS.JavaScript.Error.OnlyAuthorized" /></iman:toScript>" );
               return;
            }

            var dnArray = new Array();

            dnArray[ dnArray.length ] = tableData[ selectedIndices[ 0 ]][ 0 ];

            utilSetElementValue( "<%= UIConst.PARAM_DN_LIST    %>", pack( dnArray ));
            utilSetElementValue( "<%= UIConst.PARAM_TASK_ACTION %>", "<%= NMASConstants.PARAM_NEXT_ACTION_MAKE_DEFAULT %>" );

            utilSubmitDocumentForm( false );
         }

         function doAuthorizeSequence( selectedIndices, tableData, action )
         {
            if ( null == selectedIndices ||
                 0 == selectedIndices.length )
            {
               alert( "<iman:toScript><iman:string key = "NMAS.JavaScript.Error.NoSequenceSelected" /></iman:toScript>" );
               return;
            }

            var dnArray = new Array();

            for ( var i = 0; i < selectedIndices.length; i++ )
            {
               dnArray[ dnArray.length ] = tableData[ selectedIndices[ i ]][ 0 ];
            }

            utilSetElementValue( "<%= UIConst.PARAM_DN_LIST    %>", pack( dnArray ));
            utilSetElementValue( "<%= UIConst.PARAM_TASK_ACTION %>", action );

            utilSubmitDocumentForm( false );
         }

         function handleMenu( menuItemId, selectedIndices, tableData )
         {
            if ( menuItemId == "<%= NMASConstants.PARAM_NEXT_ACTION_NEW %>" )
            {
               utilSetElementValue(
                  "<%= UIConst.PARAM_TASK_ACTION  %>",
                  "<%= NMASConstants.PARAM_NEXT_ACTION_NEW %>" );

               utilSubmitDocumentForm( true );
            }
            else if ( menuItemId == "<%= NMASConstants.PARAM_NEXT_ACTION_DELETE %>" )
            {
               handleDeleteMethods( selectedIndices, tableData );
            }
            else if ( menuItemId == "<%= NMASConstants.PARAM_NEXT_ACTION_MAKE_DEFAULT %>" )
            {
               doMakeDefault( selectedIndices, tableData );
            }
            else if ( menuItemId == "<%= NMASConstants.PARAM_NEXT_ACTION_CLEAR_DEFAULT %>" )
            {
               utilSetElementValue(
                  "<%= UIConst.PARAM_TASK_ACTION  %>",
                  menuItemId );

               utilSubmitDocumentForm( true );
            }
            else
            {
               doAuthorizeSequence( selectedIndices, tableData, menuItemId );
            }
         }

         function updateDNListandSubmit(
            selectedDN,
            actionValue )
         {
            var dnArray = new Array();

            dnArray[ dnArray.length ] = selectedDN;

            utilSetElementValue( "<%= UIConst.PARAM_DN_LIST    %>", pack( dnArray ));
            utilSetElementValue( "<%= UIConst.PARAM_TASK_ACTION %>", actionValue    );

            utilSubmitDocumentForm( false );
         }

         function handleLink( column, row, tableData )
         {
            if ( column == 0 )
            {
               updateDNListandSubmit(
                  tableData[ row ][ column ],
                  '<%= NMASConstants.PARAM_NEXT_ACTION_EDIT %>' );
            }
         }

         // End of hidden JavaScript -->

      </script>

   </head>

   <body
      onResize = "utilPositionFooterDiv('headerDiv','bodyDiv','footerDiv')"
      onLoad   = "onPageLoad()"
      style    = "overflow: hidden" >
      <form name="LMSelectForm" method="post" action="webacc">

         <nmas:frameVars  />
         <nmas:pageHeader showFooter = "<%= !isInPropBook %>" >

            <input type="hidden" name="nextState" value="" />
            <input type="hidden" name="SelectedSequences" value="" />

            <nmas:dataTable
               id                = "methods"
               sourceData        = "<%= data %>"
               menuActionHandler = "handleMenu"
               linkActionHandler = "handleLink"
               titleKey          = "NMAS.LoginSequences" >

               <nmas:columnHeader textKey = "NMAS.Common.Column_Header.Name" />
               <nmas:columnHeader textKey = "NMAS.Common.Column_Header.Grade" align = "<%= TableCell.ALIGN_LEFT %>"  />
<%
   if ( showDefault )
   {
%>
               <nmas:columnHeader textKey = "NMAS.Common.Column_Header.DefaultSequence" />
<%
   }

   if ( showAuthorized )
   {
%>
               <nmas:columnHeader textKey = "NMAS.Common.Column_Header.AuthorizedSequence" />
<%
   }
%>

               <nmas:menuItem id = "<%= NMASConstants.PARAM_NEXT_ACTION_NEW %>"          textKey = "NMAS.Common.Menu.New"     disabled = "<%= !isLoginPolicy %>" />
               <nmas:menuItem id = "<%= NMASConstants.PARAM_NEXT_ACTION_DELETE %>"       textKey = "NMAS.Common.Menu.Delete"  disabled = "<%= !isLoginPolicy || ( null == data || 0 == data.getNumberOfRows() ) %>" />
<%
   if ( showDefault )
   {
%>
               <nmas:menuItem id = "<%= NMASConstants.PARAM_NEXT_ACTION_MAKE_DEFAULT %>"  textKey = "NMAS.Common.Menu.MakeDefault"   disabled = "<%= 0 == numAuthorized   %>" />
               <nmas:menuItem id = "<%= NMASConstants.PARAM_NEXT_ACTION_CLEAR_DEFAULT %>" textKey = "NMAS.Common.Menu.ClearDefault"  disabled = "<%= !hasDefault %>" />
<%
   }

   if ( showAuthorized )
   {
%>
               <nmas:menuItem id = "<%= NMASConstants.PARAM_NEXT_ACTION_AUTHORIZE %>"    textKey = "NMAS.Common.Menu.AuthorizeSequence"   disabled = "<%= 0 == numUnauthorized %>" />
               <nmas:menuItem id = "<%= NMASConstants.PARAM_NEXT_ACTION_DEAUTHORIZE %>"  textKey = "NMAS.Common.Menu.DeauthorizeSequence" disabled = "<%= 0 == numAuthorized   %>" />
<%
   }
%>

            </nmas:dataTable>
         </nmas:pageHeader>
      </form>

   </body>
</html>
<%
   }
   catch ( Exception e )
   {
      D.log( e );
%>
      Exception occured processing JSP page NMAS/Page_LoginSequences.jsp
<%
   }
%>
