<%/*------------------------------------------------------------------------ */
  /* %full_filespec:   LMEnhancedPswdPolicyRestrictionsPage.jsp~1:ascii:nds#1 %                      */
  /* %derived_by:      ggoodwin %                                             */
  /* %date_modified:   Thu Feb 05 11:56:52 2004 %                            */
  /*------------------------------------------------------------------------ */
  /* Copyright (c) 2002 Novell, Inc.  All rights reserved.                   */
  /*------------------------------------------------------------------------ */%>

<%@ page   pageEncoding = "utf-8"                                  %>
<%@ page   contentType  = "text/html;charset=utf-8"                %>
<%@ page   import       = "com.novell.emframe.dev.D,
                           com.novell.plugin.imanutil.HttpRequest,
                           com.novell.admin.nmas.WidgetID,
                           com.novell.admin.nmas.NMASConstants"               %>
<%@ page   import       = "com.novell.emframe.dev.eMFrameUtils"    %>
<%@ taglib uri          = "/WEB-INF/iman.tld"      prefix = "iman" %>
<%@ taglib uri          = "/WEB-INF/c.tld"         prefix = "c"    %>
<%@ taglib uri          = "/WEB-INF/util.tld"      prefix = "nmas" %>

<iman:stringtable bundle = "NMASResources" />

<%
   try
   {
      HttpRequest httpRequest  = new HttpRequest( request );

      boolean hasWriteRights = httpRequest.getAttributeAsBoolean( WidgetID.HAS_WRITE_RIGHTS, false );
      boolean hasAdminRights = httpRequest.getAttributeAsBoolean( WidgetID.HAS_ADMIN_RIGHTS, false );
      boolean requireUniquePasswords = httpRequest.getAttributeAsBoolean( WidgetID.REQUIRE_UNIQUE_PASSWORDS, false );
      boolean prohibitUserChange = httpRequest.getAttributeAsBoolean( WidgetID.PROHIBIT_USER_CHANGE, false );
      boolean allowUsersToSelfEnroll = httpRequest.getAttributeAsBoolean( WidgetID.ALLOW_USERS_TO_SELF_ENROLL, false );
      boolean allowSyncToNDS = httpRequest.getAttributeAsBoolean( WidgetID.ALLOW_SYNC_TO_NDS, false );
      boolean allowSyncToSimple = httpRequest.getAttributeAsBoolean( WidgetID.ALLOW_SYNC_TO_SIMPLE, false );
      int historySize = httpRequest.getAttributeAsInt( WidgetID.HISTORY_SIZE, 0 );
%>
<html>
   <head>
      <title></title>

      <nmas:stylesheet moduleName = "NMAS" />
      <iman:stylesheet />

      <nmas:utilScripts     moduleName = "NMAS" />
      <iman:validateNumberScripts />

      <script language="JavaScript">
      <!--
         function onPageLoad()
         {
            utilPositionFooterDiv('headerDiv','bodyDiv','footerDiv');

            utilSetFooterButtons(
               window.okButton |
               window.applyButton |
               window.cancelButton );
         }

         function isPageValid() // called when user leaves this page or applies changes
         {
            return true;
         }

         function onChangeUniquePasswords()
         {
         }

         function validateHistorySize()
         {
            if ( !validateIntegerField(
               utilGetElementByName( "<%= WidgetID.HISTORY_SIZE %>" ),
               <%= NMASConstants.MIN_HISTORY_SIZE %>,
               <%= NMASConstants.MAX_HISTORY_SIZE %> ))
            {
               utilSetElementFocus( "<%= WidgetID.HISTORY_SIZE %>" );
               return false;
            }

            return true;
         }
      //-->
      </script>
   </head>

   <body
      onResize = "utilPositionFooterDiv('headerDiv','bodyDiv','footerDiv')"
      onLoad   = "onPageLoad()"
      style    = "overflow: hidden" >

      <form name = "Form" method = "post" action = "webacc">

         <nmas:frameVars />
         <nmas:pageHeader >

            <table>
               <tr>
                  <td colspan = "3" class = "tablesubhead1">
                     <iman:string key = "NMAS.EnhancedPswdPolicy.PasswordHistory" />
                  </td>
               </tr>
               <tr>
                  <td colspan = "3">
                     <input
                        type = "checkbox"
                        name = "<%= WidgetID.REQUIRE_UNIQUE_PASSWORDS %>"
                        id   = "<%= WidgetID.REQUIRE_UNIQUE_PASSWORDS %>"
                        <% if ( !hasAdminRights && !hasWriteRights ) { %>disabled<% } %>
                        <% if ( requireUniquePasswords ) {%>checked<% } %>
                        onclick = "onChangeUniquePasswords()" /><iman:string key = "NMAS.EnhancedPswdPolicy.RequireUniquePasswords" />
                  </td>
               </tr>
               <tr>
                  <td width = "80%">
                     <iman:string key = "NMAS.EnhancedPswdPolicy.HistorySize" />
                  </td>
                  <td>
                     <input
                        type      = "text"
                        name      = "<%= WidgetID.HISTORY_SIZE %>"
                        id        = "<%= WidgetID.HISTORY_SIZE %>"
                        value     = "<%= historySize %>"
                        style     = "padding-left:3;padding-right:3;"
                        size      = "5"
                        maxlength = "3"
                        onChange  = "return validateHistorySize();" />
                  </td>
                  <td>
                     <iman:spinner elementId = "<%= WidgetID.HISTORY_SIZE %>" />
                  </td>
               </tr>
               <tr>
                  <td colspan = "3" class = "tablesubhead1">
                     <iman:string key = "NMAS.EnhancedPswdPolicy.PasswordChange" />
                  </td>
               </tr>
               <tr>
                  <td colspan = "3">
                     <input
                        type = "checkbox"
                        name = "<%= WidgetID.PROHIBIT_USER_CHANGE %>"
                        id   = "<%= WidgetID.PROHIBIT_USER_CHANGE %>"
                        <% if ( !hasAdminRights && !hasWriteRights ) { %>disabled<% } %>
                        <% if ( prohibitUserChange ) {%>checked<% } %> /><iman:string key = "NMAS.EnhancedPswdPolicy.ProhibitUserChange" />
                  </td>
               </tr>
               <tr>
                  <td colspan = "3">
                     <input
                        type = "checkbox"
                        name = "<%= WidgetID.ALLOW_USERS_TO_SELF_ENROLL %>"
                        id   = "<%= WidgetID.ALLOW_USERS_TO_SELF_ENROLL %>"
                        <% if ( !hasAdminRights && !hasWriteRights ) { %>disabled<% } %>
                        <% if ( allowUsersToSelfEnroll ) {%>checked<% } %> /><iman:string key = "NMAS.EnhancedPswdPolicy.AllowUsersSelfEnroll" />
                  </td>
               </tr>
               <tr>
                  <td colspan = "3" class = "tablesubhead1">
                     <iman:string key = "NMAS.EnhancedPswdPolicy.PasswordSync" />
                  </td>
               </tr>
               <tr>
                  <td colspan = "3">
                     <input
                        type = "checkbox"
                        name = "<%= WidgetID.ALLOW_SYNC_TO_NDS %>"
                        id   = "<%= WidgetID.ALLOW_SYNC_TO_NDS %>"
                        <% if ( !hasAdminRights && !hasWriteRights ) { %>disabled<% } %>
                        <% if ( allowSyncToNDS ) {%>checked<% } %> /><iman:string key = "NMAS.EnhancedPswdPolicy.AllowSyncToNDS" />
                  </td>
               </tr>
               <tr>
                  <td colspan = "3">
                     <input
                        type = "checkbox"
                        name = "<%= WidgetID.ALLOW_SYNC_TO_SIMPLE %>"
                        id   = "<%= WidgetID.ALLOW_SYNC_TO_SIMPLE %>"
                        <% if ( !hasAdminRights && !hasWriteRights ) { %>disabled<% } %>
                        <% if ( allowSyncToSimple ) {%>checked<% } %> /><iman:string key = "NMAS.EnhancedPswdPolicy.AllowSyncToSimple" />
                  </td>
               </tr>
            </table>
         </nmas:pageHeader>
      </form>
   </body>
</html>
<%
   }
   catch ( Exception e )
   {
      D.log( e );
%>
      Exception occured processing PropertyPage_LoginMethod_EnhancedPswd_Restrictions.jsp
<%
   }
%>
