<%
  /*------------------------------------------------------------------------ */
  /* %full_filespec:   SecurityUserClearances.jsp~2:ascii:nds#1 %              */
  /* %derived_by:      ggoodwin %                                            */
  /* %date_modified:   Wed May 10 14:30:36 2006 %                            */
  /*------------------------------------------------------------------------ */
  /* Copyright (c) 2002 Novell, Inc.  All rights reserved.                   */
  /*------------------------------------------------------------------------ */

  /* Make the global definitions required for all PKI Wizard template files  */
  /* This includes STRINGTABLE"s, ...                                        */
%>

<%@ page   pageEncoding = "utf-8"                               %>
<%@ page   contentType  = "text/html;charset=utf-8"             %>
<%@ page   import       = "com.novell.admin.nmas.NMASConstants,
                           com.novell.plugin.imanutil.KVPairList,
                           com.novell.plugin.imanutil.KeyValuePair" %>
<%@ taglib uri          = "/WEB-INF/iman.tld"   prefix = "iman" %>
<%@ taglib uri          = "/WEB-INF/c.tld"      prefix = "c"    %>
<%@ taglib uri          = "/WEB-INF/util.tld"   prefix = "nmas" %>

<iman:stringtable bundle = "NMASResources" />

<%
   try
   {
      String defaultClearance = (String)request.getAttribute( NMASConstants.PARAM_DEFAULT_CLEARANCE );
      KVPairList authorizedList = (KVPairList)request.getAttribute( NMASConstants.PARAM_AUTHORIZED_CLEARANCES );
%>
<html>
   <head>
      <title>
      </title>

      <META http-equiv= "content-type" content= "text/html;charset=iso-8859-1"/>

      <nmas:stylesheet moduleName = "NMAS" />
      <iman:stylesheet />

      <iman:eMFrameScripts />
      <iman:pageScripts    />

      <nmas:utilScripts moduleName = "NMAS" />
      <script language="JavaScript">
         <!--
         function pageInit()
         {
         }

	<%/*-------------------------------------------------------------------- */
	  /*-- adds the selected "fromCtrl" options to the "toCtrl" select 	-- */
	  /*-- and removes them from the fromCtrl select 						-- */
	  /*-------------------------------------------------------------------- */%>
		function addToRemoveFrom2( toCtrl1, toCtrl2, fromCtrl1, fromCtrl2 )
		{
			var sel = getSelectedIndex( fromCtrl1 );

			if ( sel == -1 )
				return; <%/*-- don"t do anything if nothing is selected -- */

			  /*-- handle multiple selection -- */%>
			var len = eval( "document." + fromCtrl1 + ".length" );
			var delArray = new Array();
			for ( var i=len-1; i>=0; i-- )
			{
				var isSelected = eval( "document." + fromCtrl1 + "[i].selected == true" );
				if ( isSelected )
				{
					<%/*-- create the new member -- */%>
					var value 	= eval( "document." + fromCtrl1 + ".options[i].value" );
					newMember( value, toCtrl1, true, true ); <%/*-- add to the "toCtrl1" -- */ %>
					if ( toCtrl2 != null )
					{
						newMember( value, toCtrl2, true, true ); <%/*-- add to the "toCtrl2" -- */ %>
					}

					<% /*-- remember we need to delete this one from the other list -- */%>
					delArray[i]=i;
				}
			}
			<%/*-- delete from "fromCtrl" list -- */%>
			for ( var i=delArray.length-1; i>=0; i-- )
			{
				eval( "document." + fromCtrl1 + "[delArray[i]] = null" );
				if ( fromCtrl2 != null )
				{
					eval( "document." + fromCtrl2 + "[delArray[i]] = null" );
				}
			}
		}

		function moveRight()
		{
	 		addToRemoveFrom2( 'Form.authorizedList', 'Form.clearanceList', 'Form.availableList', null  );
		}

		function moveLeft()
		{
	 		addToRemoveFrom2( 'Form.availableList', null,  'Form.authorizedList', 'Form.clearanceList' );
		}

		function isPageValid()
		{
			return true;
		}

         function onOptionMove( toDest, selOption )
         {
            if ( toDest )
            {
               utilSelectAddOption   ( "<%= NMASConstants.PARAM_DEFAULT_CLEARANCE %>", selOption.text, selOption.value );
            }
            else
            {
               utilSelectRemoveOption( "<%= NMASConstants.PARAM_DEFAULT_CLEARANCE %>", selOption.value );
            }
         }

         function isPageValid()
         {
            utilSetElementValue(
               "<%= NMASConstants.PARAM_SELECTED_CLEARANCE_LIST %>",
               packSelect(
                  utilGetElementByName(
                     "<%= NMASConstants.PARAM_AUTHORIZED_CLEARANCES %>" )));

         }

      //-->
      </script>
   </head>

   <body onLoad="return pageInit()">
      <form name="Form" method="post" action="webacc">

         <iman:messagebar />
         <iman:bookvars   />

         <input
            type  = "hidden"
            name  = "<%= NMASConstants.PARAM_SELECTED_CLEARANCE_LIST %>"
            id    = "<%= NMASConstants.PARAM_SELECTED_CLEARANCE_LIST %>"
            value = "" />

         <table width="70%">
            <tr>
               <td colspan = "3">
                  <iman:string key ="gams.AUTH_LOGIN_INSTRUCTIONS" />
               </td>
            </tr>
            <tr><td>&nbsp;</td></tr>
            <tr>
               <td colspan = "3">
                  <label><iman:string key = "gams.CLEARANCE_LABEL" /></label>&nbsp;<nobr />
                  <select
                     name  = "<%= NMASConstants.PARAM_DEFAULT_CLEARANCE %>"
                     id    = "<%= NMASConstants.PARAM_DEFAULT_CLEARANCE %>"
                     style = "width:60%"
                     size  = "1" >
<%
      for ( int i = 0; i < authorizedList.size(); i++ )
      {
         KeyValuePair kvPair = authorizedList.getKVPair( i );
%>
                        <option
                           <% if ( kvPair.getKey().equals( defaultClearance )){%>selected<%}%>
                           value = "<%= kvPair.getKey() %>" ><%= kvPair.getValue() %></option>

<%
      }
%>
                  </select>
               </td>
            </tr>
            <tr><td>&nbsp;</td></tr>
            <tr>
               <td colspan = "2">
                  <nmas:dualList
                     listId      = "clearances"
                     sourceId    = "<%= NMASConstants.PARAM_AVAILABLE_CLEARANCES  %>"
                     destId      = "<%= NMASConstants.PARAM_AUTHORIZED_CLEARANCES %>"
                     sourceData  = "${availableClearances}"
                     destData    = "${authorizedClearances}"
                     sourceLabel = "gams.AVAILABLE_CLEARANCES"
                     destLabel   = "gams.ASSIGNED_CLEARANCES"
                     sourceStyle = "width:264px"
                     destStyle   = "width:264px"
                     callback    = "onOptionMove"
                     multiple    = "true"
                     size        = "8" />
               </td>
            </tr>
            <tr><td>&nbsp;</td></tr>
      <%--
         <tr>
            <td width="50%"><iman:string key = "gams.AVAILABLE_CLEARANCES" /></td>
            <td width="1%"></td>
            <td width="50%"><iman:string key = "gams.ASSIGNED_CLEARANCES" /></td>
         </tr>
         <tr>
            <td>
				<select
					name  = "availableList"
					style = "width:100%;"
					size	= "15">
					<c:forEach items="${availableClearances}" var="element">
						<option value="<c:out value="${element}"/>" ><c:out value="${element}"/></option>
			     	</c:forEach>
				</select>
			</td>

			<%/*-- left/right arrows -- */%>
			<td valign="middle" align="left" width="1%">
				<a href="javascript:moveRight()">
				<IMG src="/NMAS/images/btnrightarrow.gif" alt="<iman:string key ="NMAS.DefineLabelsSelectSecrecyCategory" />" title="<iman:string key ="NMAS.DefineLabelsSelectSecrecyCategory" />" border="0"></a>
				<br />
				<a href="javascript:moveLeft()">
				<IMG src="/NMAS/images/btnleftarrow.gif" alt="<iman:string key ="NMAS.DefineLabelsUnselectSecrecyCategory" />" title="<iman:string key ="NMAS.DefineLabelsUnselectSecrecyCategory" />" border="0"></a>
			</td>

			<td>
				<select
					name  = "authorizedList"
					style = "width:100%;"
					size	= "15">
					<c:forEach items="${authorizedClearances}" var="element">
						<option value="<c:out value="${element}"/>" ><c:out value="${element}"/></option>
			     	</c:forEach>
				</select>
			</td>
		</tr>
      --%>
	</table>

</form>
</body></HTML> <% } catch (Exception e) { e.printStackTrace(); %>Exception occured processing JSP page<% } %>
