<%@  page pageEncoding="utf-8" contentType="text/html;charset=utf-8" import="com.novell.webaccess.common.JSPConduit, com.novell.emframe.dev.eMFrameUtils" %>
<%   JSPConduit c = JSPConduit.getJSPConduit(request);%>
<%
/*-------------------------------------------------------------------------------------------**
** Insert new option into list and keep it sorted
**-------------------------------------------------------------------------------------------- */%>
function insertIntoList( list, text, value )
{
	for ( i = 0; i < list.options.length; i++ )
	{
		if ( text.toLowerCase() < list.options[i].text.toLowerCase() )
		{
			list.options[ list.options.length ] = new Option( "", "", false, false );

			for ( j = list.options.length - 1; j > i; j-- )
			{
				list.options[ j ].text  = list.options[ j - 1 ].text;
				list.options[ j ].value = list.options[ j - 1 ].value;
			}

			var newOption = new Option( text, value, false, false );
			list.options[ i ] = newOption;

			return newOption;
		}
	}

	// If we get here, the new option belongs at the end of the list
	var newOption = new Option( text, value, false, false );
	list.options[ list.options.length ] = newOption;
	
	return newOption;
}

<%
/*-------------------------------------------------------------------------------------------**
** Create the new option and add the member name to the select
**-------------------------------------------------------------------------------------------- */%>
function newMember( optionString, ctrlName, noDuplicates, warn )
{
  	var selectLength = eval( "document." + ctrlName + ".length" );

	if ( (optionString != null) && (optionString != "") )
	{
		if ( noDuplicates == 1 )
		{
			if ( memberExists(optionString, ctrlName) > -1 )
			{
				if ( warn == true )
					alert( "<%= c.toScript(c.string("NMAS.EntryDuplicate")) %>" );
				return;
			}
		}

		<%/*-- create the new option and add it to the select -- */%>
		return insertIntoList(
			eval( "document." + ctrlName ),
			optionString,
			optionString );
	}
	return null;
}

<%/*------------------------------------------------------------------**
** see if this member"s name already exists in the list of members  **
** by going through the select options and seeing if it"s there     **
**------------------------------------------------------------------- */%>
function memberExists( strName, ctrlName )
{
	var selectLength = eval( "document." + ctrlName + ".length" );
	for ( var i=0; i<selectLength; i++ )
	{
		var cur = eval( "document." + ctrlName + ".options[i].value" );
		if ( cur == strName )
			return i;
	}

	return -1;
}

<%/*------------------------------------------------------------------**
** remove a member with value "strName" from the select control		**
**------------------------------------------------------------------- */%>
function removeMember( strName, ctrlName )
{
	var index = memberExists( strName, ctrlName );
	if ( index != -1 )
	{
		eval("document." + ctrlName + "[index] = null" );
		return true;
	}
	return false;
}

<%/*------------------------------------------------------------------**
** remove a member at index "index" from the select control			**
**------------------------------------------------------------------- */%>
function removeMemberAtIndex( index, ctrlName )
{
	if ( index != -1 )
	{
		if ( eval("document." + ctrlName + ".length") >= (index-1) )
		{
			alert( 'removing index (' + index + ') from ' + ctrlName );
			eval("document." + ctrlName + "[index] = null" );
			return true;
		}
	}
	return false;
}

<%/*------------------------------------ */
  /* remove all members from the select  */
  /*------------------------------------ */%>
function removeAllMembers( ctrlName )
{
	var selectLength = eval( "document." + ctrlName + ".length" );
	for ( var i=selectLength-1; i>=0; i-- )
	{
		eval("document." + ctrlName + ".options[i] = null" );
	}
}

<%/*-- returns the index of the selected option *don"t use for multiple select -- */%>
function getSelectedIndex( ctrlName )
{
	return ( eval("document." + ctrlName + ".selectedIndex") );
}

<%/*------------------------------------------- */
  /*-- selects the option in select control: -- */
  /*-- 	 ctrlName                          -- */
  /*-- with text equalling option value:      -- */
  /*-- 	optionText                         -- */
  /*------------------------------------------- */%>
function selectOption( ctrlName, optionText )
{
	var index = memberExists( optionText, ctrlName );
	if ( index != -1 )
	{
		eval( "document." + ctrlName + ".options[index].selected = true" );
		return true;
	}
	return false;
}

<%/*-------------------------------------------------------- */
  /*-- get the string associated with the selected option -- */
  /*-------------------------------------------------------- */%>
function getSelectedOptionText( ctrlName )
{
	var selectedIndex 	= eval( "document." + ctrlName + ".selectedIndex" );

	if ( selectedIndex == -1 )
	{
		return "";
	}

	var selectedMember 	= eval( "document." + ctrlName + ".options[selectedIndex].value" );
	if ( selectedMember == "" )
		return "";
	return selectedMember;
}

<%/*-------------------------------------------------------- */
  /*-- returns the number of selection options		 	-- */
  /*-------------------------------------------------------- */%>
function getNumberSelected( ctrlName )
{
	var selectedIndex 	= eval( "document." + ctrlName + ".selectedIndex" );

	if ( selectedIndex == -1 )
		return 0;

	var srcIndex = 0;
	var len = eval( "document." + ctrlName + ".length" );
	var countSelected = 0;
	for ( srcIndex = len - 1; srcIndex >= 0; srcIndex-- )
	{
		var isSelected = eval( "document." + ctrlName + "[srcIndex].selected == true" );
		if ( isSelected )
			countSelected++;
	}

	return countSelected;
}

<%/*--------------------------------------------------------- */
  /*-- get the strings associated with the selected options-- */
  /*-- in the multiple selection select control.			 -- */
  /*-- returns an array of 0 or more string elements		 -- */
  /*--------------------------------------------------------- */%>
function getSelectedMVOptionText( ctrlName )
{
	<%/*-- create an array to hold all the values of each selected option -- */%>
	var retArray = new Array();
	var retArrayLength = eval( "document." + ctrlName + ".length" );
	var srcIndex, dstIndex = 0;
	for ( srcIndex = 0, dstIndex = 0; srcIndex < retArrayLength; srcIndex++ )
	{
		var isSelected = eval( "document." + ctrlName + "[srcIndex].selected == true" );
		if ( isSelected == true )
			retArray[ dstIndex++ ] = eval( "document." + ctrlName + ".options[srcIndex].value" );
	}

	return retArray;
}

<%/*--------------------------------------------------------- */
  /*-- get the strings associated with all the options     -- */
  /*-- in the multiple selection select control.			 -- */
  /*-- returns an array of 0 or more string elements		 -- */
  /*--------------------------------------------------------- */%>
function getMVOptionText( ctrlName )
{
	<%/*-- create an array to hold all the values of each selected option -- */%>
	var retArray = new Array();
	var retArrayLength = eval( "document." + ctrlName + ".length" );
	var srcIndex, dstIndex = 0;
	for ( srcIndex = 0, dstIndex = 0; srcIndex < retArrayLength; srcIndex++ )
	{
		retArray[ dstIndex++ ] = eval( "document." + ctrlName + ".options[srcIndex].value" );
	}

	return retArray;
}

<%/*--------------------------------------------------------- */
  /*-- clear all the options out of the select and put in  -- */
  /*-- new options for each string in the aOptions array   -- */
  /*--------------------------------------------------------- */%>
function setSelectOptionsFromArray( ctrlName, aOptions )
{
	<%/*-- remove all options in the select -- */%>
	removeAllMembers( ctrlName );

	<%/*-- add each option in the array to the select control -- */%>
	var noDuplicates = true;
	var warn = true;
	for( var i=0; i<aOptions.length; i++ )
	{
		if ( !newMember(aOptions[i], ctrlName, noDuplicates, warn) )
			return false;
	}

	return true;
}

<%/*--------------------------------------------------------------------------- */
  /*-- moves the selected option up one row in the select control 		   -- */
  /*--------------------------------------------------------------------------- */%>
function moveOptionUp( ctrlName )
{
	if ( getNumberSelected(ctrlName) == 0 )
		return;  <%/*-- just don"t do anything if they haven"t selected anything-- */%>

	if ( getNumberSelected(ctrlName) > 1 )
	{
		alert( "<%= c.toScript(c.string("NMAS.SingleSelectOnMoveUp")) %>" );
		return;
	}

	var sel = getSelectedIndex( ctrlName );
	if ( sel == 0 )
		return;  <%/*-- just don"t do anything if it"s the top one in the select control-- */

	  /*-- save values of both options -- */%>
	var oneAboveVal = eval( "document." + ctrlName + ".options[sel-1].value" );
	var thisVal = eval( "document." + ctrlName + ".options[sel].value" );

	<%/*-- switch the options -- */%>
	eval("document." + ctrlName + ".options[sel-1] = new Option(thisVal,thisVal,false,true);" );
	eval("document." + ctrlName + ".options[sel] = new Option(oneAboveVal,oneAboveVal,false,false);" );

	return;
}

<%/*--------------------------------------------------------------------------- */
  /*-- moves the selected option down one row in the select control 		   -- */
  /*--------------------------------------------------------------------------- */%>
function moveOptionDown( ctrlName )
{
	if ( getNumberSelected(ctrlName) == 0 )
		return;  <%/*-- just don"t do anything if they haven"t selected anything-- */%>

	if ( getNumberSelected(ctrlName) > 1 )
	{
		alert( "<%= c.toScript(c.string("NMAS.SingleSelectOnMoveUp")) %>" );
		return;
	}

	var len = eval( "document." + ctrlName + ".length" );
	var sel = getSelectedIndex( ctrlName );
	if ( sel == (len - 1) )
		return;  <%/*-- just don"t do anything if it"s the bottom one in the select control-- */

	  /*-- save values of both options -- */%>
	var oneBelowVal = eval( "document." + ctrlName + ".options[sel+1].value" );
	var thisVal = eval( "document." + ctrlName + ".options[sel].value" );

	<%/*-- switch the options -- */%>
	eval("document." + ctrlName + ".options[sel+1] = new Option(thisVal,thisVal,false,true);" );
	eval("document." + ctrlName + ".options[sel] = new Option(oneBelowVal,oneBelowVal,false,false);" );

	return;
}

<%/*-------------------------------------------------------------------- */
  /*-- adds the selected "fromCtrl" options to the "toCtrl" select 	-- */
  /*-- and removes them from the fromCtrl select 						-- */
  /*-------------------------------------------------------------------- */%>
function addToRemoveFrom( toCtrl, fromCtrl )
{
	if ( eval("document." + fromCtrl + ".disabled" == true) ||
	     eval("document." + toCtrl + ".disabled" == true)
		)
		return; <%/*-- don"t do anything if either control is disabled -- */%>

	var sel = getSelectedIndex( fromCtrl );
	if ( sel == -1 )
		return; <%/*-- don"t do anything if nothing is selected -- */

	  /*-- handle multiple selection -- */%>
	var len = eval( "document." + fromCtrl + ".length" );
	var delArray = new Array();
	for ( var i=len-1; i>=0; i-- )
	{
		var isSelected = eval( "document." + fromCtrl + "[i].selected == true" );
		if ( isSelected )
		{
			<%/*-- create the new member -- */%>
			var value 	= eval( "document." + fromCtrl + ".options[i].value" );
			newMember( value, toCtrl, true, true ); <%/*-- add to the "toCtrl" -- */

			  /*-- remember we need to delete this one from the other list -- */%>
			delArray[i]=i;
		}
	}
	<%/*-- delete from "fromCtrl" list -- */%>
	for ( var i=delArray.length-1; i>=0; i-- )
	{
		eval( "document." + fromCtrl + "[delArray[i]] = null" );
	}
}

