<%
  /*------------------------------------------------------------------------ */
  /* %full_filespec:   WizardPage_LoginSequence_Name.jsp~4:ascii:iman_plg#1 %              */
  /* %derived_by:      ggoodwin %                                            */
  /* %date_modified:   Wed May 24 12:34:36 2006 %                            */
  /*------------------------------------------------------------------------ */
  /* Copyright (c) 2002 Novell, Inc.  All rights reserved.                   */
  /*------------------------------------------------------------------------ */

  /* Make the global definitions required for all PKI Wizard template files  */
  /* This includes STRINGTABLE"s, ...                                        */
%>

<%@ page   pageEncoding = "utf-8"                               %>
<%@ page   contentType  = "text/html;charset=utf-8"             %>
<%@ page   import       = "com.novell.emframe.dev.D,
                           com.novell.plugin.imanutil.HttpRequest,
                           com.novell.plugin.imanutil.constants.UIConst,
                           com.novell.plugin.imanutil.StringUtil"            %>
<%@ page   import       = "com.novell.plugin.imanutil.UIWizard" %>
<%@ page   import       = "com.novell.admin.nmas.NMASConstants" %>
<%@ taglib uri          = "/WEB-INF/iman.tld"   prefix = "iman" %>
<%@ taglib uri          = "/WEB-INF/c.tld"      prefix = "c"    %>
<%@ taglib uri          = "/WEB-INF/util.tld"   prefix = "nmas" %>

<iman:stringtable bundle = "NMASResources" />

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">

<%
   try
   {
      boolean isWizardPage;
      String  sequenceName;
      String  sequenceType;
      String  sequenceGrade;

      HttpRequest httpRequest = new HttpRequest( request );

      isWizardPage  = httpRequest.hasAttribute( UIConst.PARAM_WIZARD );
      sequenceName  = httpRequest.getAttributeAsString( NMASConstants.PARAM_SEQUENCE_NAME );
      sequenceType  = httpRequest.getAttributeAsString( NMASConstants.PARAM_SEQUENCE_TYPE, "OR" );
      sequenceGrade = httpRequest.getAttributeAsString( NMASConstants.PARAM_SEQUENCE_GRADE );

%>
<html>
   <head>
      <title>
      </title>

      <META http-equiv= "content-type" content= "text/html;charset=iso-8859-1"/>

      <nmas:stylesheet moduleName = "NMAS" />
      <iman:stylesheet />

      <iman:eMFrameScripts />
      <iman:pageScripts    />

      <nmas:utilScripts moduleName = "NMAS" />

      <script language= "JavaScript">
         <!--
         function onPageLoad()
         {
            utilPositionFooterDiv('headerDiv','bodyDiv','footerDiv');

<%
      if ( isWizardPage )
      {
%>
            utilSetFooterButtons(
               window.backButton |
               window.finishButton |
               window.cancelButton );
<%
      }
      else
      {
%>
            utilSetFooterButtons(
               window.okButton |
               window.applyButton |
               window.cancelButton );
<%
      }
%>
         }

         function isPageValid()
         {
<%
      if ( isWizardPage )
      {
      }
%>
            utilSetElementValue(
               "<%= NMASConstants.PARAM_SELECTED_LOGIN_METHODS_LIST %>",
               packSelect(
                  utilGetElementByName(
                     "<%= NMASConstants.PARAM_DEST_LOGIN_METHODS %>" )));

            utilSetElementValue(
               "<%= NMASConstants.PARAM_SELECTED_POST_LOGIN_METHODS_LIST %>",
               packSelect(
                  utilGetElementByName(
                     "<%= NMASConstants.PARAM_DEST_POST_LOGIN_METHODS %>" )));

             return true;
         }

         //-->
      </script>

   </head>

   <body
      onResize = "utilPositionFooterDiv('headerDiv','bodyDiv','footerDiv')"
      onLoad   = "onPageLoad()"
      style    = "overflow: hidden" >

      <form
         name     = "Wiz_MainForm"
         method   = "post"
         onSubmit = "return( false )"
         action   = "<c:out value = "${ContextPath}"/>/servlet/frameservice" >

         <nmas:frameVars  />
         <nmas:pageHeader wizard = "<%= isWizardPage %>" >

         <input
            type  = "hidden"
            name  = "<%= NMASConstants.PARAM_SELECTED_LOGIN_METHODS_LIST %>"
            id    = "<%= NMASConstants.PARAM_SELECTED_LOGIN_METHODS_LIST %>"
            value = "" />

         <input
            type  = "hidden"
            name  = "<%= NMASConstants.PARAM_SELECTED_POST_LOGIN_METHODS_LIST %>"
            id    = "<%= NMASConstants.PARAM_SELECTED_POST_LOGIN_METHODS_LIST %>"
            value = "" />

         <div class = "margintop1">
            <table cellspacing = "0" >
<%
   if ( isWizardPage )
   {
%>
               <tr>
                  <td align = "right" >
                     <label><iman:string key = "NMAS.FieldLabel.LoginSequenceName" /></label>&nbsp;
                  </td>
                  <td>
                     <input
                        type      = "text"
                        name      = "<%= NMASConstants.PARAM_SEQUENCE_NAME %>"
                        id        = "<%= NMASConstants.PARAM_SEQUENCE_NAME %>"
                        size      = "50"
                        maxlength = "64"
                        value     = "<%= sequenceName %>" />
                  </td>
               </tr>
<%
   }
   else
   {
%>
               <tr>
                  <td align = "right">
                     <label><iman:string key = "NMAS.LoginSequenceGrade" /></label>&nbsp;
                  </td>
                  <td>
                     <%= sequenceGrade %>
                  </td>
               </tr>
<%
   }
%>
               <tr>
                  <td align = "right" >
                     <label><iman:string key = "NMAS.LoginSequenceType"/></label>&nbsp;
                  </td>
                  <td>
                     <select
                        name = "<%= NMASConstants.PARAM_SEQUENCE_TYPE %>"
                        size = "1" >
                        <option
<%
   if ( sequenceType.equals( StringUtil.getString( NMASConstants.NMAS_RESOURCES, "NMAS.Sequence.TYPE_AND", request )))
   {
%>
                           selected
<%
   }
%>
                           value = "<iman:string key = "NMAS.Sequence.TYPE_AND"/>" ><iman:string key = "NMAS.Sequence.TYPE_AND" /></option>
                        <option
<%
   if ( sequenceType.equals( StringUtil.getString( NMASConstants.NMAS_RESOURCES, "NMAS.Sequence.TYPE_OR", request )))
   {
%>
                           selected
<%
   }
%>
                           value = "<iman:string key = "NMAS.Sequence.TYPE_OR" />" ><iman:string key = "NMAS.Sequence.TYPE_OR"  /></option>
                     </select>
                  </td>
               </tr>
            </table>
         </div>
         <div class = "margintop1">
            <table>
               <tr>
                  <td colspan = "2">
                     <nmas:dualList
                        listId      = "loginMethods"
                        sourceId    = "<%= NMASConstants.PARAM_SOURCE_LOGIN_METHODS %>"
                        destId      = "<%= NMASConstants.PARAM_DEST_LOGIN_METHODS %>"
                        sourceData  = "${loginMethods_available}"
                        destData    = "${loginMethods_selected}"
                        sourceLabel = "NMAS.AvailableLoginMethods"
                        destLabel   = "NMAS.SelectedLoginMethods"
                        destOrdered = "true"
                        sourceStyle = "width:264px"
                        destStyle   = "width:264px"
                        multiple    = "true"
                        size        = "8" />
                  </td>
               </tr>
               <tr>
                  <td colspan = "2">
                     <nmas:dualList
                        listId      = "postLoginMethods"
                        sourceId    = "<%= NMASConstants.PARAM_SOURCE_POST_LOGIN_METHODS %>"
                        destId      = "<%= NMASConstants.PARAM_DEST_POST_LOGIN_METHODS %>"
                        sourceData  = "${postLoginMethods_available}"
                        destData    = "${postLoginMethods_selected}"
                        sourceLabel = "NMAS.AvailablePostLoginMethods"
                        destLabel   = "NMAS.SelectedPostLoginMethods"
                        destOrdered = "true"
                        sourceStyle = "width:264px"
                        destStyle   = "width:264px"
                        multiple    = "true"
                        size        = "8" />
                  </td>
               </tr>
            </table>
         </div>
         </nmas:pageHeader>
      </form>
   </body>
</html>
<%
   }
   catch ( Exception e )
   {
      D.log( e );
%>
   Exception occured processing JSP page NMAS/WizardPage_LoginSequence_Name.jsp
<%
   }
%>
