<%/*------------------------------------------------------------------------ */
  /* %full_filespec:   LMEnhancedPswdPolicyNumericCharsPage.jsp~1:ascii:nds#1 %                      */
  /* %derived_by:      ggoodwin %                                             */
  /* %date_modified:   Thu Feb 05 11:56:50 2004 %                            */
  /*------------------------------------------------------------------------ */
  /* Copyright (c) 2002 Novell, Inc.  All rights reserved.                   */
  /*------------------------------------------------------------------------ */%>

<%@ page   pageEncoding = "utf-8"                                  %>
<%@ page   contentType  = "text/html;charset=utf-8"                %>
<%@ page   import       = "com.novell.emframe.dev.D,
                           com.novell.plugin.imanutil.HttpRequest,
                           com.novell.admin.nmas.WidgetID"               %>
<%@ page   import       = "com.novell.emframe.dev.eMFrameUtils"    %>
<%@ taglib uri          = "/WEB-INF/iman.tld"      prefix = "iman" %>
<%@ taglib uri          = "/WEB-INF/c.tld"         prefix = "c"    %>
<%@ taglib uri          = "/WEB-INF/util.tld"      prefix = "nmas" %>

<iman:stringtable bundle = "NMASResources" />

<%
   try
   {
      HttpRequest httpRequest  = new HttpRequest( request );

      boolean hasWriteRights = httpRequest.getAttributeAsBoolean( WidgetID.HAS_WRITE_RIGHTS, false );
      boolean hasAdminRights = httpRequest.getAttributeAsBoolean( WidgetID.HAS_ADMIN_RIGHTS, false );

      boolean allowNumericChars = httpRequest.getAttributeAsBoolean( WidgetID.ALLOW_NUMERIC_CHARACTERS, false );
      int     minNumericChars   = httpRequest.getAttributeAsInt( WidgetID.MINIMUM_NUMERIC_CHARACTERS, 0 );
      int     minNumericCharsLB = httpRequest.getAttributeAsInt( WidgetID.MINIMUM_NUMERIC_CHARACTERS_LB, 0 );
      int     minNumericCharsUB = httpRequest.getAttributeAsInt( WidgetID.MINIMUM_NUMERIC_CHARACTERS_UB, 0 );
      boolean firstCharCanBeNumeric = httpRequest.getAttributeAsBoolean( WidgetID.FIRST_CHAR_CAN_BE_NUMERIC, false );
      int     maxNumericChars   = httpRequest.getAttributeAsInt( WidgetID.MAXIMUM_NUMERIC_CHARACTERS, 0 );
      int     maxNumericCharsLB = httpRequest.getAttributeAsInt( WidgetID.MAXIMUM_NUMERIC_CHARACTERS_LB, 0 );
      int     maxNumericCharsUB = httpRequest.getAttributeAsInt( WidgetID.MAXIMUM_NUMERIC_CHARACTERS_UB, 0 );
      boolean lastCharCanBeNumeric = httpRequest.getAttributeAsBoolean( WidgetID.LAST_CHAR_CAN_BE_NUMERIC, false );

      boolean allowSpecialChars = httpRequest.getAttributeAsBoolean( WidgetID.ALLOW_SPECIAL_CHARACTERS, false );
      int     minSpecialChars   = httpRequest.getAttributeAsInt( WidgetID.MINIMUM_SPECIAL_CHARACTERS, 0 );
      int     minSpecialCharsLB = httpRequest.getAttributeAsInt( WidgetID.MINIMUM_SPECIAL_CHARACTERS_LB, 0 );
      int     minSpecialCharsUB = httpRequest.getAttributeAsInt( WidgetID.MINIMUM_SPECIAL_CHARACTERS_UB, 0 );
      boolean firstCharCanBeSpecial = httpRequest.getAttributeAsBoolean( WidgetID.FIRST_CHAR_CAN_BE_SPECIAL, false );
      int     maxSpecialChars   = httpRequest.getAttributeAsInt( WidgetID.MAXIMUM_SPECIAL_CHARACTERS, 0 );
      int     maxSpecialCharsLB = httpRequest.getAttributeAsInt( WidgetID.MAXIMUM_SPECIAL_CHARACTERS_LB, 0 );
      int     maxSpecialCharsUB = httpRequest.getAttributeAsInt( WidgetID.MAXIMUM_SPECIAL_CHARACTERS_UB, 0 );
      boolean lastCharCanBeSpecial = httpRequest.getAttributeAsBoolean( WidgetID.LAST_CHAR_CAN_BE_SPECIAL, false );
%>
   <head>
      <title></title>

      <nmas:stylesheet moduleName = "NMAS" />
      <iman:stylesheet />

      <nmas:utilScripts     moduleName = "NMAS" />
      <iman:validateNumberScripts />

      <script language="JavaScript">
      <!--
         function onPageLoad()
         {
            utilPositionFooterDiv('headerDiv','bodyDiv','footerDiv');

            utilSetFooterButtons(
               window.okButton |
               window.applyButton |
               window.cancelButton );

            onChangeNumeric();
            onChangeSpecial();
         }

         function isPageValid() // called when user leaves this page or applies changes
         {
            return true;
         }

         function onChangeNumeric()
         {
            if ( utilIsElementChecked( "<%= WidgetID.ALLOW_NUMERIC_CHARACTERS %>" ))
            {
               utilEnableControl( "<%= WidgetID.MINIMUM_NUMERIC_CHARACTERS %>", true );
               utilEnableControl( "<%= WidgetID.MAXIMUM_NUMERIC_CHARACTERS %>", true );
               utilEnableControl( "<%= WidgetID.FIRST_CHAR_CAN_BE_NUMERIC  %>", true );
               utilEnableControl( "<%= WidgetID.LAST_CHAR_CAN_BE_NUMERIC   %>", true );
            }
            else
            {
               utilEnableControl( "<%= WidgetID.MINIMUM_NUMERIC_CHARACTERS %>", false );
               utilEnableControl( "<%= WidgetID.MAXIMUM_NUMERIC_CHARACTERS %>", false );
               utilEnableControl( "<%= WidgetID.FIRST_CHAR_CAN_BE_NUMERIC  %>", false );
               utilEnableControl( "<%= WidgetID.LAST_CHAR_CAN_BE_NUMERIC   %>", false );

               utilSetElementChecked( "<%= WidgetID.FIRST_CHAR_CAN_BE_NUMERIC %>", false );
               utilSetElementChecked( "<%= WidgetID.LAST_CHAR_CAN_BE_NUMERIC  %>", false );
            }
         }

         function onChangeSpecial()
         {
            if ( utilIsElementChecked( "<%= WidgetID.ALLOW_SPECIAL_CHARACTERS %>" ))
            {
               utilEnableControl( "<%= WidgetID.MINIMUM_SPECIAL_CHARACTERS %>", true );
               utilEnableControl( "<%= WidgetID.MAXIMUM_SPECIAL_CHARACTERS %>", true );
               utilEnableControl( "<%= WidgetID.FIRST_CHAR_CAN_BE_SPECIAL  %>", true );
               utilEnableControl( "<%= WidgetID.LAST_CHAR_CAN_BE_SPECIAL   %>", true );
            }
            else
            {
               utilEnableControl( "<%= WidgetID.MINIMUM_SPECIAL_CHARACTERS %>", false );
               utilEnableControl( "<%= WidgetID.MAXIMUM_SPECIAL_CHARACTERS %>", false );
               utilEnableControl( "<%= WidgetID.FIRST_CHAR_CAN_BE_SPECIAL  %>", false );
               utilEnableControl( "<%= WidgetID.LAST_CHAR_CAN_BE_SPECIAL   %>", false );

               utilSetElementChecked( "<%= WidgetID.FIRST_CHAR_CAN_BE_SPECIAL %>", false );
               utilSetElementChecked( "<%= WidgetID.LAST_CHAR_CAN_BE_SPECIAL  %>", false );
            }
         }

         function validateMinNumericCharacters()
         {
            if ( !validateIntegerField(
               utilGetElementByName( "<%= WidgetID.MINIMUM_NUMERIC_CHARACTERS %>" ),
               <%= minNumericCharsLB %>,
               <%= minNumericCharsUB %> ))
            {
               utilSetElementFocus( "<%= WidgetID.MINIMUM_NUMERIC_CHARACTERS %>" );
               return false;
            }

            return true;
         }

         function validateMaxNumericCharacters()
         {
            if ( !validateIntegerField(
               utilGetElementByName( "<%= WidgetID.MAXIMUM_NUMERIC_CHARACTERS %>" ),
               <%= maxNumericCharsLB %>,
               <%= maxNumericCharsUB %> ))
            {
               utilSetElementFocus( "<%= WidgetID.MAXIMUM_NUMERIC_CHARACTERS %>" );
               return false;
            }

            return true;
         }

         function validateMinSpecialCharacters()
         {
            if ( !validateIntegerField(
               utilGetElementByName( "<%= WidgetID.MINIMUM_SPECIAL_CHARACTERS %>" ),
               <%= minSpecialCharsLB %>,
               <%= minSpecialCharsUB %> ))
            {
               utilSetElementFocus( "<%= WidgetID.MINIMUM_SPECIAL_CHARACTERS %>" );
               return false;
            }

            return true;
         }

         function validateMaxSpecialCharacters()
         {
            if ( !validateIntegerField(
               utilGetElementByName( "<%= WidgetID.MAXIMUM_SPECIAL_CHARACTERS %>" ),
               <%= maxSpecialCharsLB %>,
               <%= maxSpecialCharsUB %> ))
            {
               utilSetElementFocus( "<%= WidgetID.MAXIMUM_SPECIAL_CHARACTERS %>" );
               return false;
            }

            return true;
         }

      //-->
      </script>
   </head>

   <body
      onResize = "utilPositionFooterDiv('headerDiv','bodyDiv','footerDiv')"
      onLoad   = "onPageLoad()"
      style    = "overflow: hidden" >

      <form name = "Form" method = "post" action = "webacc">

         <nmas:frameVars />
         <nmas:pageHeader >

            <table>
               <tr>
                  <td colspan = "6">
                     <input
                        type = "checkbox"
                        name = "<%= WidgetID.ALLOW_NUMERIC_CHARACTERS %>"
                        id   = "<%= WidgetID.ALLOW_NUMERIC_CHARACTERS %>"
                        <% if ( !hasAdminRights && !hasWriteRights ) { %>disabled<% } %>
                        <% if ( allowNumericChars ) { %>checked<% } %>
                        onclick = "onChangeNumeric()" /><iman:string key = "NMAS.EnhancedPswdPolicy.AllowNumericChars" />
                  </td>
               </tr>
               <tr>
                  <td>&nbsp;</td>
                  <td colspan = "3" class = "tablesubhead1">
                     <iman:string key = "NMAS.EnhancedPswdPolicy.NumericCharCount" />
                  </td>
                  <td>&nbsp;</td>
                  <td colspan = "1" class = "tablesubhead1">
                     <iman:string key = "NMAS.EnhancedPswdPolicy.NumericCharBehavior" />
                  </td>
               </tr>
               <tr>
                  <td>&nbsp;</td>
                  <td>
                     <iman:string key = "NMAS.EnhancedPswdPolicy.MinNumericCharacters" />
                  </td>
                  <td>
                     <input
                        type      = "text"
                        name      = "<%= WidgetID.MINIMUM_NUMERIC_CHARACTERS %>"
                        id        = "<%= WidgetID.MINIMUM_NUMERIC_CHARACTERS %>"
                        value     = "<%= minNumericChars %>"
                        style     = "padding-left:3;padding-right:3;"
                        size      = "5"
                        maxlength = "3"
                        onChange  = "return validateMinNumericCharacters()" />
                  </td>
                  <td>
                     <iman:spinner elementId = "<%= WidgetID.MINIMUM_NUMERIC_CHARACTERS %>" />
                  </td>
                  <td>&nbsp;</td>
                  <td>
                     <input
                        type = "checkbox"
                        name = "<%= WidgetID.FIRST_CHAR_CAN_BE_NUMERIC %>"
                        id   = "<%= WidgetID.FIRST_CHAR_CAN_BE_NUMERIC %>"
                        <% if ( !hasAdminRights && !hasWriteRights ) { %>disabled<% } %>
                        <% if ( firstCharCanBeNumeric ) { %>checked<% } %> /><iman:string key = "NMAS.EnhancedPswdPolicy.FirstCharCanBeNumeric" />
                  </td>
               </tr>
               <tr>
                  <td>&nbsp;</td>
                  <td>
                     <iman:string key = "NMAS.EnhancedPswdPolicy.MaxNumericCharacters" />
                  </td>
                  <td>
                     <input
                        type      = "text"
                        name      = "<%= WidgetID.MAXIMUM_NUMERIC_CHARACTERS %>"
                        id        = "<%= WidgetID.MAXIMUM_NUMERIC_CHARACTERS %>"
                        value     = "<%= maxNumericChars %>"
                        style     = "padding-left:3;padding-right:3;"
                        size      = "5"
                        maxlength = "3"
                        onChange  = "return validateMaxNumericCharacters()" />
                  </td>
                  <td>
                     <iman:spinner elementId = "<%= WidgetID.MAXIMUM_NUMERIC_CHARACTERS %>" />
                  </td>
                  <td>&nbsp;</td>
                  <td>
                     <input
                        type = "checkbox"
                        name = "<%= WidgetID.LAST_CHAR_CAN_BE_NUMERIC %>"
                        id   = "<%= WidgetID.LAST_CHAR_CAN_BE_NUMERIC %>"
                        <% if ( !hasAdminRights && !hasWriteRights ) { %>disabled<% } %>
                        <% if ( lastCharCanBeNumeric ) { %>checked<% } %> /><iman:string key = "NMAS.EnhancedPswdPolicy.LastCharCanBeNumeric" />
                  </td>
               </tr>
               <tr>
                  <td height = "16" align = "left" valign = "middle" colspan = "7">
                     &nbsp;
                  </td>
               </tr>
               <tr>
                  <td colspan = "6">
                     <input
                        type = "checkbox"
                        name = "<%= WidgetID.ALLOW_SPECIAL_CHARACTERS %>"
                        id   = "<%= WidgetID.ALLOW_SPECIAL_CHARACTERS %>"
                        <% if ( !hasAdminRights && !hasWriteRights ) { %>disabled<% } %>
                        <% if ( allowSpecialChars ) { %>checked<% } %>
                        onclick = "onChangeSpecial()" /><iman:string key = "NMAS.EnhancedPswdPolicy.AllowSpecialChars" />
                  </td>
               </tr>
               <tr>
                  <td>&nbsp;</td>
                  <td colspan = "3" class = "tablesubhead1">
                     <iman:string key = "NMAS.EnhancedPswdPolicy.SpecialCharCount" />
                  </td>
                  <td>&nbsp;</td>
                  <td colspan = "1" class = "tablesubhead1">
                     <iman:string key = "NMAS.EnhancedPswdPolicy.SpecialCharBehavior" />
                  </td>
               </tr>
               <tr>
                  <td>&nbsp;</td>
                  <td>
                     <iman:string key = "NMAS.EnhancedPswdPolicy.MinSpecialCharacters" />
                  </td>
                  <td>
                     <input
                        type      = "text"
                        name      = "<%= WidgetID.MINIMUM_SPECIAL_CHARACTERS %>"
                        id        = "<%= WidgetID.MINIMUM_SPECIAL_CHARACTERS %>"
                        value     = "<%= minSpecialChars %>"
                        style     = "padding-left:3;padding-right:3;"
                        size      = "5"
                        maxlength = "3"
                        onChange  = "return validateMinSpecialCharacters()" />
                  </td>
                  <td>
                     <iman:spinner elementId = "<%= WidgetID.MINIMUM_SPECIAL_CHARACTERS %>" />
                  </td>
                  <td>&nbsp;</td>
                  <td>
                     <input
                        type = "checkbox"
                        name = "<%= WidgetID.FIRST_CHAR_CAN_BE_SPECIAL %>"
                        id   = "<%= WidgetID.FIRST_CHAR_CAN_BE_SPECIAL %>"
                        <% if ( !hasAdminRights && !hasWriteRights ) { %>disabled<% } %>
                        <% if ( firstCharCanBeSpecial ) { %>checked<% } %> /><iman:string key = "NMAS.EnhancedPswdPolicy.FirstCharCanBeSpecial" />
                  </td>
               </tr>
               <tr>
                  <td>&nbsp;</td>
                  <td>
                     <iman:string key = "NMAS.EnhancedPswdPolicy.MaxSpecialCharacters" />
                  </td>
                  <td>
                     <input
                        type      = "text"
                        name      = "<%= WidgetID.MAXIMUM_SPECIAL_CHARACTERS %>"
                        id        = "<%= WidgetID.MAXIMUM_SPECIAL_CHARACTERS %>"
                        value     = "<%= maxSpecialChars %>"
                        style     = "padding-left:3;padding-right:3;"
                        size      = "5"
                        maxlength = "3"
                        onChange  = "return validateMaxSpecialCharacters()" />
                  </td>
                  <td>
                     <iman:spinner elementId = "<%= WidgetID.MAXIMUM_SPECIAL_CHARACTERS %>" />
                  </td>
                  <td>&nbsp;</td>
                  <td>
                     <input
                        type = "checkbox"
                        name = "<%= WidgetID.LAST_CHAR_CAN_BE_SPECIAL %>"
                        id   = "<%= WidgetID.LAST_CHAR_CAN_BE_SPECIAL %>"
                        <% if ( !hasAdminRights && !hasWriteRights ) { %>disabled<% } %>
                        <% if ( lastCharCanBeSpecial ) { %>checked<% } %> /><iman:string key = "NMAS.EnhancedPswdPolicy.LastCharCanBeSpecial" />
                  </td>
               </tr>
            </table>
         </nmas:pageHeader >
      </form>
   </body>
</html>
<%
   }
   catch ( Exception e )
   {
      D.log( e );
%>
      Exception occured processing PropertyPage_LoginMethod_EnhancedPswd_NumericChars.jsp
<%
   }
%>
