<%/*------------------------------------------------------------------------ */
  /* %full_filespec:   PropertyPage_LoginMethod_SAML_Affiliates.jsp~2:ascii:iman_plg#1 %                      */
  /* %derived_by:      ggoodwin %                                             */
  /* %date_modified:   Wed May 10 14:30:27 2006 %                            */
  /*------------------------------------------------------------------------ */
  /* Copyright (c) 2002 Novell, Inc.  All rights reserved.                   */
  /*------------------------------------------------------------------------ */%>

<%@ page   pageEncoding = "utf-8"                                        %>
<%@ page   contentType  = "text/html;charset=utf-8"                      %>
<%@ page   import       = "com.novell.emframe.dev.D,
                           com.novell.admin.nmas.NMASConstants"                     %>
<%@ page   import       = "com.novell.plugin.imanutil.HttpRequest"       %>
<%@ page   import       = "com.novell.admin.nmas.WidgetID"               %>
<%@ page   import       = "com.novell.plugin.imanutil.StringList"        %>
<%@ page   import       = "com.novell.plugin.imanutil.tags.Table"        %>
<%@ page   import       = "com.novell.plugin.imanutil.TableCellText"     %>
<%@ page   import       = "com.novell.plugin.imanutil.constants.UIConst" %>
<%@ page   import       = "com.novell.emframe.dev.eMFrameUtils"          %>
<%@ taglib uri          = "/WEB-INF/iman.tld"            prefix = "iman" %>
<%@ taglib uri          = "/WEB-INF/c.tld"               prefix = "c"    %>
<%@ taglib uri          = "/WEB-INF/util.tld"            prefix = "nmas" %>

<iman:stringtable bundle = "NMASResources" />
<iman:stringtable bundle = "DevResources"  />

<%
   try
   {
      Table table = (Table)request.getAttribute( WidgetID.TABLE_DATA );
%>
<html>
   <head>
      <title></title>

      <nmas:stylesheet moduleName = "NMAS" />
      <iman:stylesheet />

      <iman:eMFrameScripts />
      <nmas:dataTableScripts />
      <nmas:utilScripts     moduleName = "NMAS" />

      <script language="JavaScript">
      <!--
         function onPageLoad()
         {
            utilPositionFooterDiv('headerDiv','bodyDiv','footerDiv');

            utilSetFooterButtons(
               window.okButton |
               window.applyButton |
               window.cancelButton );
         }

         function handleDeleteAffiliates( selectedIndices, tableData )
         {
            if ( selectedIndices == null || selectedIndices.length == 0 )
            {
               <%/* User has to select at least one item from the list.      */%>
               alert( "<iman:toScript><iman:string key = "NMAS.MustSelect" /></iman:toScript>" );
               return;
            }

            var delArray = new Array();
            var delIndex = 0;

            for ( i = 0; i < selectedIndices.length; i++ )
            {
                delArray[ delIndex ] = tableData[ selectedIndices[ i ]][ 0 ];
                delIndex++;
            }

            if ( confirm( "<iman:toScript><iman:string key = "NMAS.LMDelete.Subset.Confirm" /></iman:toScript>" ))
            {
               utilSetElementValue(
                  "<%= UIConst.PARAM_TASK_ACTION  %>",
                  "<%= NMASConstants.PARAM_NEXT_ACTION_DELETE %>" );

               utilSetElementValue(
                  "<%= UIConst.PARAM_DN_LIST %>",
                  pack( delArray ));

               utilSubmitDocumentForm( true );
            }
         }

         function handleMenu( menuItemId, selectedIndices, tableData )
         {
            if ( menuItemId == "<%= NMASConstants.PARAM_NEXT_ACTION_NEW %>" )
            {
               utilSetElementValue(
                  "<%= UIConst.PARAM_TASK_ACTION  %>",
                  "<%= NMASConstants.PARAM_NEXT_ACTION_NEW %>" );

               utilSubmitDocumentForm( true );
            }
            else if ( menuItemId == "<%= NMASConstants.PARAM_NEXT_ACTION_DELETE %>" )
            {
               handleDeleteAffiliates( selectedIndices, tableData );
            }
         }

         function updateDNListandSubmit(
            selectedDN,
            actionValue )
         {
            var dnArray = new Array();

            dnArray[ dnArray.length ] = selectedDN;

            utilSetElementValue( "<%= UIConst.PARAM_DN_LIST     %>", pack( dnArray ));
            utilSetElementValue( "<%= UIConst.PARAM_TASK_ACTION %>", actionValue    );

            utilSubmitDocumentForm( false );
         }

         function handleLink( column, row, tableData )
         {
            if ( column == 0 )
            {
               updateDNListandSubmit(
                  tableData[ row ][ column ],
                  '<%= NMASConstants.PARAM_NEXT_ACTION_EDIT %>' );
            }
         }

      //-->
      </script>
   </head>

   <body
      onResize = "utilPositionFooterDiv('headerDiv','bodyDiv','footerDiv')"
      onLoad   = "onPageLoad()"
      style    = "overflow: hidden" >

      <form name = "Form" method = "post" action = "webacc">

         <nmas:frameVars />
         <nmas:pageHeader >

            <nmas:dataTable
               id                = "affiliates"
               menuActionHandler = "handleMenu"
               linkActionHandler = "handleLink"
               sourceData        = "<%= table %>" >

               <nmas:columnHeader textKey = "NMAS.Common.Column_Header.Name" />

               <nmas:menuItem textKey = "NMAS.Common.Menu.New"    id = "<%= NMASConstants.PARAM_NEXT_ACTION_NEW %>" />
               <nmas:menuItem textKey = "NMAS.Common.Menu.Delete" id = "<%= NMASConstants.PARAM_NEXT_ACTION_DELETE %>" disabled = "<%= null == table || 0 == table.getNumberOfRows() %>" />

            </nmas:dataTable>

         </nmas:pageHeader>
      </form>
   </body>
</html>
<%
   }
   catch ( Exception e )
   {
      D.log( e );
%>
      Exception occured processing PropertyPage_LoginMethod_SAML_General.jsp
<%
   }
%>

