<%
  /*------------------------------------------------------------------------ */
  /* %full_filespec:   PropertyPage_Settings.jsp~idc_nmas#3:ascii:iman_plg#1 %                  */
  /* %derived_by:      prabhishek %                                             */
  /* %date_modified:   Wed May 10 14:31:00 2006 %                            */
  /*------------------------------------------------------------------------ */
  /* Copyright (c) 2002 Novell, Inc.  All rights reserved.                   */
  /*------------------------------------------------------------------------ */%>

<%@ page   pageEncoding = "utf-8"                                    %>
<%@ page   contentType  = "text/html;charset=utf-8"                  %>
<%@ page   import       = "com.novell.emframe.dev.eMFrameUtils,
                           com.novell.plugin.imanutil.HttpRequest,
                           com.novell.admin.nmas.NMASConstants,
                           com.novell.admin.nmas.WidgetID,
                           com.novell.plugin.imanutil.constants.UIConst,
                           com.novell.emframe.dev.D"      %>
<%@ taglib uri          = "/WEB-INF/iman.tld"        prefix = "iman" %>
<%@ taglib uri          = "/WEB-INF/c.tld"           prefix = "c"    %>
<%@ taglib uri          = "/WEB-INF/fmt.tld"         prefix = "fmt"  %>
<%@ taglib uri          = "/WEB-INF/util.tld"        prefix = "nmas" %>

<iman:stringtable bundle = "NMASResources" />

<%
   try
   {
      HttpRequest httpRequest = new HttpRequest( request );

      boolean showLoginDelay  = httpRequest.getAttributeAsBoolean( WidgetID.SHOW_LOGIN_DELAY );
      int     loginDelay      = httpRequest.getAttributeAsInt  ( WidgetID.LOGIN_DELAY, NMASConstants.DEFAULT_LOGIN_DELAY );
      boolean showAuditing    = httpRequest.getAttributeAsBoolean( WidgetID.SHOW_ENABLE_AUDITING );
      boolean enableAuditing  = httpRequest.getAttributeAsBoolean( WidgetID.ENABLE_AUDITING );
%>
<html>
   <head>
      <title></title>

      <nmas:stylesheet moduleName = "NMAS" />
      <iman:stylesheet />

      <iman:eMFrameScripts />
      <nmas:dataTableScripts />

      <iman:osScripts />
      <iman:pageScripts />

      <nmas:utilScripts moduleName = "NMAS" />

   <script language="JavaScript">
   <!--
      function pageInit()
      {
      }

      <%/*--------------------------------------------------------------------------------------------- */
        /*--       Enable select controls and select contents according to state of "restrict" button  */
        /*--------------------------------------------------------------------------------------------- */%>
      function handleRestrict( doRestrict )
      {
         utilSubmitDocumentForm( true );
      }

      function isPageValid() <%/*-- called when user leaves this page or applies changes -- */%>
      {
         return true;
      }

      //-->
      </script>
   </head>

   <body onLoad = "return pageInit()" >
      <form name="Form" method="post" action="webacc">

         <nmas:frameVars  />
         <iman:messagebar />
         <iman:bookvars   />

<%
      if ( showLoginDelay )
      {
%>
         <table cellpadding = '0' cellspacing = '0'>
            <tr>
               <td>
                  <label><iman:toScript><iman:string key = "NMAS.FailedLoginDelayTime" /></iman:toScript></label>&nbsp;
               </td>
               <td>
                  <input
                     type  = "text"
                     name  = "<%= WidgetID.LOGIN_DELAY %>"
                     id    = "<%= WidgetID.LOGIN_DELAY %>"
                     size  = "5"
                     style = "text-align: right"
                     value = "<%= loginDelay %>" />
               </td>
               <td class = "instructions">
                  &nbsp;<iman:toScript><iman:string key = "NMAS.TimeInSeconds" /></iman:toScript>
               </td>
               <td width = "100%">&nbsp;</td>
            </tr>
<%
      }

      if ( showAuditing && showLoginDelay )
      {
%>
            <tr>
               <td>&nbsp;</td>
            </tr>
<%
      }

      if ( showAuditing )
      {
%>
            <tr>
               <td colspan = "3" >
                  <input
                     type = "checkbox"
                     name = "<%= WidgetID.ENABLE_AUDITING %>"
                     id   = "<%= WidgetID.ENABLE_AUDITING %>"
                     <% if ( enableAuditing ) {%>checked<% } %>
                     value = "true" />&nbsp;<label>Enable auditing</label>
               </td>
            </tr>
         </table>
<%
      }
%>
      </form>
   </body>
</html>
<%
   }
   catch (Exception e)
   {
      D.log( e );
%>
      Exception occured processing PropertyPage_UserSequences.jsp
<%
   }
%>
