<%
   /*------------------------------------------------------------------------ */
   /* %full_filespec:   WizardPage_LoginMethod_Results.jsp~1:ascii:iman_plg#1 %           */
   /* %derived_by:      ggoodwin %                                             */
   /* %date_modified:   Fri Aug 11 10:09:40 2006 %                            */
   /*------------------------------------------------------------------------ */
   /* Copyright (c) 2002 Novell, Inc.  All rights reserved.                   */
   /*------------------------------------------------------------------------ */

   /* This page is expecting the following variables.  */
   /*      PKI.NumResults  */
   /*      PKI.Result.n.User      - Name of the nth user  */
   /*      PKI.Result.n.Value   - Value of the nth result  */

   /* This page will send the following information when the form is submitted.  */
   /*      taskComplete = true  */
%>
<%@ page   pageEncoding = "utf-8"                                        %>
<%@ page   contentType  = "text/html;charset=utf-8"                      %>
<%@ page   import       = "com.novell.emframe.dev.D"                     %>
<%@ page   import       = "com.novell.plugin.imanutil.HttpRequest"       %>
<%@ page   import       = "com.novell.plugin.imanutil.tags.Table"        %>
<%@ page   import       = "com.novell.admin.nmas.WidgetID"               %>
<%@ page   import       = "com.novell.plugin.imanutil.constants.UIConst" %>
<%@ taglib uri          = "/WEB-INF/c.tld"               prefix = "c"    %>
<%@ taglib uri          = "/WEB-INF/iman.tld"            prefix = "iman" %>
<%@ taglib uri          = "/WEB-INF/util.tld"            prefix = "nmas" %>

<iman:stringtable bundle = "NMASResources" />

 <!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<%
    try
    {
       HttpRequest httpRequest;
       Table       tableData;
       boolean     showRestartIManagerMessage;

       httpRequest = new HttpRequest( request );

       tableData = (Table)httpRequest.getAttribute( WidgetID.TABLE_DATA );
       showRestartIManagerMessage = httpRequest.getAttributeAsBoolean( "ShowRestartiManagerMessage" );

%>
 <html>
    <head>
       <title>
       </title>

       <META http-equiv = "content-type" content = "text/html;charset=iso-8859-1"/>

       <nmas:stylesheet moduleName = "NMAS" />
       <iman:stylesheet />

       <nmas:dataTableScripts />

       <nmas:utilScripts moduleName = "NMAS"/>

       <script type = "text/javascript" language = "JavaScript">
          <!--

             function pageInit()
             {
                utilPositionFooterDiv( 'headerDiv', 'bodyDiv', 'footerDiv' );

                utilSetFooterButtons( window.closeButton );
             }
          //-->
       </script>
    </head>


    <body
       onResize = "utilPositionFooterDiv( 'headerDiv', 'bodyDiv', 'footerDiv' )"
       onLoad   = "pageInit();"
       style    = "overflow: hidden" >

       <form
          name   = "Wiz_MainForm"
          method = "post"
          action = "<c:out value = "${ContextPath}" />/servlet/frameservice" >

          <nmas:frameVars />
          <nmas:pageHeader wizard = "true" >

             <nmas:dataTable
                id         = "results"
                sourceData = "<%= tableData %>"
                readOnly   = "true" >

                <nmas:columnHeader textKey = "NMAS.Common.Column_Header.Name"   />
                <nmas:columnHeader textKey = "NMAS.Common.Column_Header.Result" align = "left" />

             </nmas:dataTable>

<%
   if ( showRestartIManagerMessage )
   {
%>
             <div class = "margintop3 instructions" >
                <iman:string key = "NMAS.WIZARD_RESTART_IMAN" />
             </div>
<%
   }
%>


          </nmas:pageHeader>
       </form>
    </body>
 </html>
<%
    }
    catch ( Exception e )
    {
       D.log( e );
%>
       Exception occured processing WizardPage_LoginMethod_Results.jsp
<%
    }
%>
